package me.springframework.di.spring;

import java.util.ResourceBundle;
import java.text.MessageFormat;

import com.agilejava.blammo.LoggingKitAdapter;
import com.agilejava.blammo.BlammoLogger;
import com.agilejava.blammo.MessageProducer;

public class BlammoQDoxAugmentation_LoggerImpl 
  implements me.springframework.di.spring.QDoxAugmentation.Logger, BlammoLogger
{

  private ResourceBundle bundle;

  private LoggingKitAdapter adapter;
  
  private Interceptor interceptor;

  public BlammoQDoxAugmentation_LoggerImpl() {
    bundle = ResourceBundle.getBundle("me/springframework/di/spring/BlammoQDoxAugmentation_Logger");
    interceptor = new DefaultInterceptor();
  }

  public void setLoggingKitAdapter(LoggingKitAdapter adapter) {
    this.adapter = adapter;
  }
  
  public void setInterceptor(Interceptor interceptor) {
    this.interceptor = interceptor;
  }

  public LoggingKitAdapter getLoggingKitAdapter() {
    return adapter;
  }

  public void logAttributing(final java.lang.String name) {
    if (!interceptor.accepts("E0000001", null, "logAttributing")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000001");
        Object[] args = new Object[] { name };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logUnresolvedConstructorArgumentType() {
    if (!interceptor.accepts("E0000002", null, "logUnresolvedConstructorArgumentType")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000002");
        Object[] args = new Object[] {  };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("warn", __producer);
  }

  public void logConstructorArgumentTypeMismatch(final java.lang.String expected, final com.thoughtworks.qdox.model.Type actual) {
    if (!interceptor.accepts("E0000003", null, "logConstructorArgumentTypeMismatch")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000003");
        Object[] args = new Object[] { expected, actual };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logConstructorArgumentTypeIsNull() {
    if (!interceptor.accepts("E0000004", null, "logConstructorArgumentTypeIsNull")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000004");
        Object[] args = new Object[] {  };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("error", __producer);
  }

  public void logNumberOfArgumentsDontMatch() {
    if (!interceptor.accepts("E0000005", null, "logNumberOfArgumentsDontMatch")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000005");
        Object[] args = new Object[] {  };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logCheckConstructor(final java.lang.String callSignature) {
    if (!interceptor.accepts("E0000006", null, "logCheckConstructor")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000006");
        Object[] args = new Object[] { callSignature };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logNoMatchingFactoryInstanceMethod(final me.springframework.di.base.MutableInstance instance) {
    if (!interceptor.accepts("E0000007", null, "logNoMatchingFactoryInstanceMethod")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000007");
        Object[] args = new Object[] { instance };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("error", __producer);
  }

  public void logNoMatchingFactoryMethod(final me.springframework.di.base.MutableInstance instance) {
    if (!interceptor.accepts("E0000008", null, "logNoMatchingFactoryMethod")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000008");
        Object[] args = new Object[] { instance };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("error", __producer);
  }

  public void logNoMatchingConstructor(final me.springframework.di.base.MutableInstance instance) {
    if (!interceptor.accepts("E0000009", null, "logNoMatchingConstructor")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000009");
        Object[] args = new Object[] { instance };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("error", __producer);
  }

  public void logNoSuchProperty(final java.lang.String propertyName, final java.lang.String className) {
    if (!interceptor.accepts("E0000010", null, "logNoSuchProperty")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000010");
        Object[] args = new Object[] { propertyName, className };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("error", __producer);
  }

  public void logFoundFactory(final java.lang.String instance, final java.lang.String factoryInstance, final java.lang.String factoryMethod, final java.lang.String type) {
    if (!interceptor.accepts("E0000011", null, "logFoundFactory")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000011");
        Object[] args = new Object[] { instance, factoryInstance, factoryMethod, type };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logGuaranteeingTypeKnown(final java.lang.String id, final boolean known) {
    if (!interceptor.accepts("E0000012", null, "logGuaranteeingTypeKnown")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000012");
        Object[] args = new Object[] { id, new Boolean(known) };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logComparingArguments(final int size, final boolean match) {
    if (!interceptor.accepts("E0000013", null, "logComparingArguments")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000013");
        Object[] args = new Object[] { new Integer(size), new Boolean(match) };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logFactoryBean(final java.lang.String name, final java.lang.String factoryInstance, final java.lang.String factoryMethod) {
    if (!interceptor.accepts("E0000014", null, "logFactoryBean")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000014");
        Object[] args = new Object[] { name, factoryInstance, factoryMethod };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logFactoryMethod(final java.lang.String name, final java.lang.String factoryMethod) {
    if (!interceptor.accepts("E0000015", null, "logFactoryMethod")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000015");
        Object[] args = new Object[] { name, factoryMethod };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logPlainOldConstructor(final java.lang.String name) {
    if (!interceptor.accepts("E0000016", null, "logPlainOldConstructor")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000016");
        Object[] args = new Object[] { name };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

  public void logInformConstructorArguments(final java.lang.String name) {
    if (!interceptor.accepts("E0000017", null, "logInformConstructorArguments")) return;
    final MessageProducer __producer = new MessageProducer() {
      public String getMessage() {
        String __message = bundle.getString("me.springframework.di.spring.E0000017");
        Object[] args = new Object[] { name };
        __message = MessageFormat.format(__message, args);
        return __message;
      }
    };
    adapter.log("debug", __producer);
  }

}